<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Apredendo IndexedDB</title>
    <script src="js/app/models/Negocicao.js"></script>
</head>
<body>
    <script>
        var connection;
        var  openRequest = window.indexedDB.open('auluraframe', 3);

        openRequest.onupgradeneeded = e => {
            console.log('Criar ou alterar um banco já existenre');

            let minhaConection = e.target.result;

            if(minhaConection.objectStoreNames.contains('negociacoes')){
                minhaConection.deleteObjectStore('negociacoes');
            }

            minhaConection.createObjectStore('negociacoes', {autoIncrement: true});
        }

        openRequest.onsuccess = e => {
            console.log('Conexão obtida com sucesso');
            connection = e.target.result;
        }

        openRequest.onerror = e => {
            console.log(e.target.error);
        }

        function adiciona(){
            let transaction = connection.transaction(['negociacoes'], 'readwrite');

            let store = transaction.objectStore('negociacoes');

            let negociacao = new Negociacao(new Date(), 1, 200);

            let request = store.add(negociacao);

            

            request.onsuccess = e => {
                console.log('Negociações incluida com sucesso');
            };

            request.onerror = e => {
                console.log('Não foi possível incluir a negociação');
            };


            
        }

        function listarTodos(){
                let transaction = connection.transaction(['negociacoes'], 'readwrite');
                let store = transaction.objectStore('negociacoes');
                let cursor = store.openCursor();
                let negociacoes = [];
                
                cursor.onsuccess = e => {
                   let atual = e.target.result;
                   if(atual){
                       let dado = atual.value;

                       negociacoes.push(new Negociacao(dado._data, dado._quantidade, dado._valor));

                       atual.continue();
                   }else{
                       console.log(negociacoes);
                   }
                };

                cursor.onerror = e => {
                    console.log(e.target.error.name);
                }
            }
    </script>
</body>
</html>